2 # The Girocco installation script
3 # We will OVERWRITE basedir!
7 if [ -z "$MAKE" ]; then
8 echo "ERROR: MAKE not set" >&2
9 echo "Please run install.sh using 'make install'" >&2
10 echo "or set MAKE to the name of the GNU make executable" >&2
14 # Run perl module checker
15 if [ ! -x toolbox
/check-perl-modules.pl
]; then
16 echo "ERROR: missing toolbox/check-perl-modules.pl!" >&2
19 toolbox
/check-perl-modules.pl
21 # What Config should we use?
22 [ -n "$GIROCCO_CONF" ] || GIROCCO_CONF
=Girocco
::Config
23 echo "*** Initializing using $GIROCCO_CONF..."
25 # First run Girocco::Config consistency checks
26 perl
-I.
-M$GIROCCO_CONF -e ''
31 [ -z "$cfg_owning_group" ] || owngroup
=":$cfg_owning_group"
32 if [ -n "$cfg_httpspushurl" -a -z "$cfg_certsdir" ]; then
33 echo "ERROR: \$httpspushurl is set but \$certsdir is not!" >&2
34 echo "ERROR: perhaps you have an incorrect Config.pm?" >&2
39 echo "*** Checking for compiled utilities..."
40 if [ ! -x src
/can_user_push
]; then
41 echo "ERROR: src/can_user_push is not built! Did you _REALLY_ read INSTALL?" >&2
42 echo "ERROR: perhaps you forgot to run make?" >&2
45 if [ ! -x src
/can_user_push_http
]; then
46 echo "ERROR: src/can_user_push_http is not built! Did you _REALLY_ read INSTALL?" >&2
47 echo "ERROR: perhaps you forgot to run make?" >&2
50 if [ ! -x src
/getent
]; then
51 echo "ERROR: src/getent is not built! Did you _REALLY_ read INSTALL?" >&2
52 echo "ERROR: perhaps you forgot to run make?" >&2
55 if [ ! -x src
/get_user_uuid
]; then
56 echo "ERROR: src/get_user_uuid is not built! Did you _REALLY_ read INSTALL?" >&2
57 echo "ERROR: perhaps you forgot to run make?" >&2
62 echo "*** Checking for ezcert..."
63 if [ ! -f ezcert.git
/CACreateCert
]; then
64 echo "ERROR: ezcert.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
69 echo "*** Checking for git..."
70 if [ ! -x "$cfg_git_bin" ]; then
71 echo "ERROR: $cfg_git_bin does not exist or is not executable" >&2
74 if ! git_version
="$("$cfg_git_bin" --version)"; then
75 echo "ERROR: $cfg_git_bin --version failed" >&2
78 case "$git_version" in
81 echo "ERROR: '$cfg_git_bin --version' output does not start with 'git version '" >&2
84 case "$cfg_git_bin" in /*) :;; *)
85 echo 'ERROR: $Girocco::Config::git_bin must be set to an absolute path' >&2
91 if [ "$LOGNAME" = root
-a -n "$SUDO_USER" -a "$SUDO_USER" != root
]; then
92 find "$@" -user root
-print0 2>/dev
/null | \
93 xargs $
(: |
xargs echo -r) -0 chown
"$SUDO_USER:$(id -gn "$SUDO_USER")"
94 elif [ "$LOGNAME" = root
-a -z "$SUDO_USER" -o "$SUDO_USER" = root
]; then
95 echo "*** WARNING: running make as root w/o sudo may leave root-owned: $*"
99 echo "*** Setting up basedir..."
100 "$MAKE" --no-print-directory --quiet apache.conf
101 chown_make apache.conf
102 "$MAKE" --no-print-directory --quiet -C src
104 rm -fr "$cfg_basedir"
105 mkdir
-p "$cfg_basedir"
106 cp -pR Girocco jobd taskd gitweb html
jobs toolbox hooks apache.conf shlib.sh bin screen
"$cfg_basedir"
107 cp -p src
/can_user_push src
/can_user_push_http src
/get_user_uuid ezcert.git
/CACreateCert cgi
/authrequired.cgi
"$cfg_basedir/bin"
108 [ -n "$cfg_httpspushurl" ] ||
rm -f "$cfg_basedir"/html
/rootcert.html
"$cfg_basedir"/html
/httpspush.html
109 [ -n "$cfg_mob" ] ||
rm -f "$cfg_basedir"/html
/mob.html
111 # Put the correct Config in place
112 [ "$GIROCCO_CONF" = "Girocco::Config" ] ||
cp "$(echo "$GIROCCO_CONF" | sed 's#::#/#g; s/$/.pm/')" "$cfg_basedir/Girocco/Config.pm"
115 echo "*** Preprocessing scripts..."
116 perl
-I.
-M$GIROCCO_CONF -i -p \
117 -e 's/(?<!")\@basedir\@/"$Girocco::Config::basedir"/g;' \
118 -e 's/(?<=")\@basedir\@/$Girocco::Config::basedir/g;' \
119 -e 's/\@reporoot\@/"$Girocco::Config::reporoot"/g;' \
120 -e 's/\@jailreporoot\@/"$Girocco::Config::jailreporoot"/g;' \
121 -e 's/\@chroot\@/"$Girocco::Config::chroot"/g;' \
122 -e 's/\@webadmurl\@/"$Girocco::Config::webadmurl"/g;' \
123 -e 's/\@screen_acl_file\@/"$Girocco::Config::screen_acl_file"/g;' \
124 -e 's/\@mob\@/"$Girocco::Config::mob"/g;' \
125 "$cfg_basedir"/jobs
/*.sh
"$cfg_basedir"/jobd
/*.sh \
126 "$cfg_basedir"/taskd
/*.sh
"$cfg_basedir"/gitweb
/*.sh \
127 "$cfg_basedir"/shlib.sh
"$cfg_basedir"/hooks
/* \
128 "$cfg_basedir"/toolbox
/* "$cfg_basedir"/bin
/git-
* \
129 "$cfg_basedir"/bin
/create-
* "$cfg_basedir"/bin
/update-
* \
130 "$cfg_basedir"/bin
/authrequired.cgi
"$cfg_basedir"/screen
/*
132 # Dump all the cfg_ and defined_ variables to shlib_vars.sh
133 get_girocco_config_var_list
> "$cfg_basedir"/shlib_vars.sh
135 if [ -n "$cfg_mirror" ]; then
136 echo "--- Remember to start $cfg_basedir/taskd/taskd.pl"
138 echo "--- Also remember to either start $cfg_basedir/jobd/jobd.sh, or add this"
139 echo "--- to the crontab of $cfg_mirror_user (adjust frequency on number of repos):"
140 echo "*/30 * * * * /usr/bin/nice -n 18 $cfg_basedir/jobd/jobd.sh -q --all-once"
143 echo "*** Setting up repository root..."
144 mkdir
-p "$cfg_reporoot" "$cfg_reporoot-recyclebin"
145 if [ "$cfg_owning_group" ]; then
146 chgrp
"$cfg_owning_group" "$cfg_reporoot" ||
echo "WARNING: Cannot chgrp $cfg_owning_group $cfg_reporoot"
147 chgrp
"$cfg_owning_group" "$cfg_reporoot-recyclebin" ||
echo "WARNING: Cannot chgrp $cfg_owning_group $cfg_reporoot-recyclebin"
149 chmod 02775 "$cfg_reporoot" ||
echo "WARNING: Cannot chmod $cfg_reporoot properly"
150 chmod 02775 "$cfg_reporoot-recyclebin" ||
echo "WARNING: Cannot chmod $cfg_reporoot-recyclebin properly"
153 if [ -n "$cfg_chrooted" ]; then
154 echo "*** Setting up chroot jail for pushing..."
155 if [ "$(id -u)" -eq 0 ]; then
158 echo "WARNING: Skipping jail setup, not root"
163 echo "*** Setting up jail configuration (project database)..."
164 [ "$(id -u)" -eq 0 ] || .
/jailsetup.sh dbonly
165 mkdir
-p "$cfg_chroot" "$cfg_chroot/etc"
166 touch "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group"
167 chown
"$cfg_mirror_user""$owngroup" "$cfg_chroot/etc" ||
168 echo "WARNING: Cannot chown $cfg_mirror_user$owngroup $cfg_chroot/etc"
169 chown
"$cfg_cgi_user""$owngroup" "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group" ||
170 echo "WARNING: Cannot chown $cfg_cgi_user$owngroup the files"
171 chmod g
+w
"$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group" ||
172 echo "WARNING: Cannot chmod g+w the etc/passwd and/or etc/group files"
173 chmod 02775 "$cfg_chroot/etc" ||
echo "WARNING: Cannot chmod 02775 $cfg_chroot/etc"
175 echo "*** Setting up gitweb from git.git..."
176 if [ ! -f git.git
/Makefile
]; then
177 echo "ERROR: git.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
180 mkdir
-p "$cfg_webroot" "$cfg_cgiroot"
181 (cd git.git
&& "$MAKE" --no-print-directory --quiet NO_SUBDIR
=: bindir
="$(dirname "$cfg_git_bin")" gitweb
&& \
182 chown_make gitweb
&& \
183 cp gitweb
/gitweb.cgi
"$cfg_cgiroot" && \
184 cp gitweb
/static
/*.png gitweb
/static
/*.css gitweb
/static
/*.js
"$cfg_webroot")
187 echo "*** Setting up git-browser from git-browser.git..."
188 if [ ! -f git-browser.git
/git-browser.cgi
]; then
189 echo "ERROR: git-browser.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
192 mkdir
-p "$cfg_webroot"/git-browser
"$cfg_cgiroot"
193 (cd git-browser.git
&& cp git-browser.cgi
"$cfg_cgiroot" \
194 && cp -r *.html
*.js
*.css js.lib JSON
"$cfg_webroot"/git-browser
)
195 ln -sf "$cfg_webroot/git-browser/JSON" "$cfg_cgiroot"
196 cat >"$cfg_cgiroot"/git-browser.conf
<<EOT
198 warehouse: $cfg_reporoot
200 cat >"$cfg_webroot"/git-browser
/GitConfig.js
<<EOT
201 cfg_gitweb_url="$cfg_gitweburl/"
202 cfg_browsercgi_url="$cfg_webadmurl/git-browser.cgi"
206 echo "*** Setting up darcs-fast-export from bzr-fastimport.git..."
207 if [ ! -d bzr-fastimport.git
/exporters
/darcs
/ ]; then
208 echo "ERROR: bzr-fastimport.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
211 mkdir
-p "$cfg_basedir"/bin
212 cp bzr-fastimport.git
/exporters
/darcs
/darcs-fast-export
"$cfg_basedir"/bin
215 echo "*** Setting up hg-fast-export from fast-export.git..."
216 if [ ! -f fast-export.git
/hg-fast-export.py
-o ! -f fast-export.git
/hg2git.py
]; then
217 echo "ERROR: fast-export.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
220 mkdir
-p "$cfg_basedir"/bin
221 cp fast-export.git
/hg-fast-export.py fast-export.git
/hg2git.py
"$cfg_basedir"/bin
224 echo "*** Setting up our part of the website..."
225 mkdir
-p "$cfg_webroot" "$cfg_cgiroot"
226 cp cgi
/*.cgi gitweb
/gitweb_config.perl
"$cfg_cgiroot"
227 rm -f "$cfg_cgiroot"/authrequired.cgi
228 [ -z "$cfg_httpspushurl" ] ||
cp "$cfg_basedir"/bin
/authrequired.cgi
"$cfg_cgiroot"
229 [ -n "$cfg_httpspushurl" ] ||
rm -f "$cfg_cgiroot"/usercert.cgi
230 ln -fs "$cfg_basedir"/Girocco
"$cfg_cgiroot"
231 [ -z "$cfg_webreporoot" ] ||
{ rm -f "$cfg_webreporoot" && ln -s "$cfg_reporoot" "$cfg_webreporoot"; }
232 if [ -z "$cfg_httpspushurl" ]; then
233 grep -v 'rootcert[.]html' gitweb
/indextext.html
> "$cfg_webroot/indextext.html"
235 cp gitweb
/indextext.html
"$cfg_webroot"
237 mv "$cfg_basedir"/html
/*.css
"$cfg_basedir"/html
/*.js
"$cfg_webroot"
238 cp mootools.js
"$cfg_webroot"
239 cp htaccess
"$cfg_webroot/.htaccess"
240 cp git-favicon.ico
"$cfg_webroot/favicon.ico"
241 cp robots.txt
"$cfg_webroot"
242 cat gitweb
/gitweb.css
>>"$cfg_webroot"/gitweb.css
245 if [ -n "$cfg_httpspushurl" ]; then
246 echo "*** Setting up SSL certificates..."
248 if [ "$cfg_rsakeylength" -gt "$bits" ] 2>/dev
/null
; then
249 bits
="$cfg_rsakeylength"
251 mkdir
-p "$cfg_certsdir"
252 [ -d "$cfg_certsdir" ]
254 if [ -e "$cfg_certsdir/girocco_www_crt.pem" ]; then
256 openssl x509 -in "$cfg_certsdir/girocco_www_crt.pem
" -noout -subject | \
261 [ -e "$cfg_certsdir/girocco_client_crt.pem" -a \
262 -e "$cfg_certsdir/girocco_client_key.pem" -a \
263 -e "$cfg_certsdir/girocco_www_key.pem" -a \
264 -e "$cfg_certsdir/girocco_www_crt.pem" -a "$wwwcertcn" = "/CN=$cfg_httpsdnsname" -a \
265 -e "$cfg_certsdir/girocco_root_crt.pem" ] || needroot
=1
266 if [ -n "$needroot" -a ! -e "$cfg_certsdir/girocco_root_key.pem" ]; then
267 rm -f "$cfg_certsdir/girocco_root_crt.pem" "$cfg_certsdir/girocco_root_key.pem"
268 openssl genrsa
-f4 -out "$cfg_certsdir/girocco_root_key.pem" $bits
269 chmod 0600 "$cfg_certsdir/girocco_root_key.pem"
270 rm -f "$cfg_certsdir/girocco_root_crt.pem"
271 echo "Created new root key"
273 if [ ! -e "$cfg_certsdir/girocco_root_crt.pem" ]; then
274 ezcert.git
/CACreateCert
--root --key "$cfg_certsdir/girocco_root_key.pem" \
275 --out "$cfg_certsdir/girocco_root_crt.pem" "girocco $cfg_nickname root certificate"
276 rm -f "$cfg_certsdir/girocco_www_crt.pem" "$cfg_certsdir/girocco_www_chain.pem"
277 rm -f "$cfg_certsdir/girocco_client_crt.pem" "$cfg_certsdir/girocco_client_suffix.pem"
278 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
279 rm -f "$cfg_chroot/etc/sshcerts"/*.pem
280 echo "Created new root certificate"
282 if [ ! -e "$cfg_certsdir/girocco_www_key.pem" ]; then
283 openssl genrsa
-f4 -out "$cfg_certsdir/girocco_www_key.pem" $bits
284 chmod 0600 "$cfg_certsdir/girocco_www_key.pem"
285 rm -f "$cfg_certsdir/girocco_www_crt.pem"
286 echo "Created new www key"
288 if [ ! -e "$cfg_certsdir/girocco_www_crt.pem" -o "$wwwcertcn" != "/CN=$cfg_httpsdnsname" ]; then
289 openssl rsa
-in "$cfg_certsdir/girocco_www_key.pem" -pubout |
290 ezcert.git
/CACreateCert
--server --key "$cfg_certsdir/girocco_root_key.pem" \
291 --cert "$cfg_certsdir/girocco_root_crt.pem" \
292 --out "$cfg_certsdir/girocco_www_crt.pem" "$cfg_httpsdnsname"
293 echo "Created www certificate"
295 if [ ! -e "$cfg_certsdir/girocco_www_chain.pem" ]; then
296 cat "$cfg_certsdir/girocco_root_crt.pem" > "$cfg_certsdir/girocco_www_chain.pem"
297 echo "Created www certificate chain file"
299 if [ ! -e "$cfg_certsdir/girocco_client_key.pem" ]; then
300 openssl genrsa
-f4 -out "$cfg_certsdir/girocco_client_key.pem" $bits
301 chmod 0640 "$cfg_certsdir/girocco_client_key.pem"
302 rm -f "$cfg_certsdir/girocco_client_crt.pem"
303 echo "Created new client key"
305 if [ ! -e "$cfg_certsdir/girocco_client_crt.pem" ]; then
306 openssl rsa
-in "$cfg_certsdir/girocco_client_key.pem" -pubout |
307 ezcert.git
/CACreateCert
--subca --key "$cfg_certsdir/girocco_root_key.pem" \
308 --cert "$cfg_certsdir/girocco_root_crt.pem" \
309 --out "$cfg_certsdir/girocco_client_crt.pem" "girocco $cfg_nickname client authority"
310 rm -f "$cfg_certsdir/girocco_client_suffix.pem"
311 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
312 rm -f "$cfg_chroot/etc/sshcerts"/*.pem
313 echo "Created client certificate"
315 if [ ! -e "$cfg_certsdir/girocco_client_suffix.pem" ]; then
316 cat "$cfg_certsdir/girocco_client_crt.pem" > "$cfg_certsdir/girocco_client_suffix.pem"
317 echo "Created client certificate suffix file"
319 cat "$cfg_rootcert" > "$cfg_webroot/${cfg_nickname}_root_cert.pem"
320 if [ -n "$cfg_mob" ]; then
321 if [ ! -e "$cfg_certsdir/girocco_mob_user_key.pem" ]; then
322 openssl genrsa
-f4 -out "$cfg_certsdir/girocco_mob_user_key.pem" $bits
323 chmod 0640 "$cfg_certsdir/girocco_client_key.pem"
324 rm -f "$cfg_certsdir/girocco_mob_user_crt.pem"
325 echo "Created new mob user key"
327 if [ ! -e "$cfg_certsdir/girocco_mob_user_crt.pem" ]; then
328 openssl rsa
-in "$cfg_mobuserkey" -pubout |
329 ezcert.git
/CACreateCert
--client --key "$cfg_clientkey" \
330 --cert "$cfg_clientcert" \
331 --out "$cfg_certsdir/girocco_mob_user_crt.pem" 'mob'
332 echo "Created mob user client certificate"
334 cat "$cfg_mobuserkey" > "$cfg_webroot/${cfg_nickname}_mob_key.pem"
335 cat "$cfg_mobusercert" "$cfg_clientcertsuffix" > "$cfg_webroot/${cfg_nickname}_mob_user.pem"
337 rm -f "$cfg_webroot/${cfg_nickname}_mob_key.pem" "$cfg_webroot/${cfg_nickname}_mob_user.pem"
340 rm -f "$cfg_webroot/${cfg_nickname}_root_cert.pem"
341 rm -f "$cfg_webroot/${cfg_nickname}_mob_key.pem" "$cfg_webroot/${cfg_nickname}_mob_user.pem"
345 echo "*** Finalizing permissions..."
346 chown
-R -h "$cfg_mirror_user""$owngroup" "$cfg_basedir" "$cfg_webroot" "$cfg_cgiroot"
347 [ -z "$cfg_httpspushurl" ] || chown
-R -h "$cfg_mirror_user""$owngroup" "$cfg_certsdir"